'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  text-align: center;\n  font-weight: bold;\n'], ['\n  text-align: center;\n  font-weight: bold;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.throttle');

var _lodash4 = _interopRequireDefault(_lodash3);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _spinner = require('./static/spinner.gif');

var _spinner2 = _interopRequireDefault(_spinner);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _LiContainer = require('./components/LiContainer');

var _LiContainer2 = _interopRequireDefault(_LiContainer);

var _PresentationInput = require('./components/PresentationInput');

var _PresentationInput2 = _interopRequireDefault(_PresentationInput);

var _ComboboxInput = require('./components/ComboboxInput');

var _ComboboxInput2 = _interopRequireDefault(_ComboboxInput);

var _TypeaheadDiv = require('./components/TypeaheadDiv');

var _TypeaheadDiv2 = _interopRequireDefault(_TypeaheadDiv);

var _TypeaheadContainer = require('./components/TypeaheadContainer');

var _TypeaheadContainer2 = _interopRequireDefault(_TypeaheadContainer);

var _UlContainer = require('./components/UlContainer');

var _UlContainer2 = _interopRequireDefault(_UlContainer);

var _LoadingImg = require('./components/LoadingImg');

var _LoadingImg2 = _interopRequireDefault(_LoadingImg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EmptyDefaultTemplate = _styledComponents2.default.div(_templateObject);

var defaultLoadingTemplate = function defaultLoadingTemplate(props) {
  return _react2.default.createElement(_LoadingImg2.default, {
    src: _spinner2.default,
    className: props.className,
    height: props.height,
    dir: props.dir
  });
};

defaultLoadingTemplate.propTypes = {
  height: _react2.default.PropTypes.number,
  dir: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string
};

var EmptyTemplate = function EmptyTemplate() {
  return _react2.default.createElement(
    EmptyDefaultTemplate,
    null,
    'No items'
  );
};

var Typeahead = function (_PureComponent) {
  (0, _inherits3.default)(Typeahead, _PureComponent);

  function Typeahead(props) {
    (0, _classCallCheck3.default)(this, Typeahead);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Typeahead.__proto__ || (0, _getPrototypeOf2.default)(Typeahead)).call(this, props));

    _this._getValueByIndex = function (options, index, displayKey) {
      if (_immutable2.default.List.isList(options)) {
        return String(options && options.size && options.get(index) && options.get(index)[displayKey] || _this.state.value);
      }

      return String(options && options.length && options[index] && options[index][displayKey] || _this.state.value);
    };

    _this._getSelectedIndex = function (options, index) {
      return index > 0 ? index % _this._getOptionsCount(options) : index;
    };

    _this._onDocActivate = function () {
      _this.setState({
        dropdownVisible: false,
        emptyVisible: false
      });
    };

    _this._onFocus = function () {
      var hasOptions = _this._getOptionsCount(_this.props.options) > 0;

      _this.setState({
        dropdownVisible: hasOptions,
        emptyVisible: _this.state.showEmpty && !hasOptions
      });
    };

    _this._onClick = function (e) {
      e.nativeEvent.stopImmediatePropagation();
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }
    };

    _this._onBlur = function (e) {
      if (_this.props.onBlur) {
        _this.props.onBlur(e);
      }
    };

    _this._onChange = function (e) {
      var value = String(e.target.value);
      var dir = (0, _utils2.default)(_this._inputTypeAhead._input);
      var hint = dir === 'rtl' ? false : _this.state.hint;
      var hasOptions = _this._getOptionsCount(_this.state.options) > 0;
      var minLength = _this.state.minLength;

      if (_this.state.minLength && value.length >= minLength) {
        _this._fetchDataHandler(value);
      }

      if (_this.props.onChange) {
        _this.props.onChange(e);
      }

      _this.setState({
        value: value,
        selectedIndex: -1,
        dropdownVisible: hasOptions,
        hint: hint,
        direction: dir
      });
    };

    _this._defaultFetchHandler = function (value) {
      if (_this.props.onFetchData) {
        _this.props.onFetchData(value);
      }
    };

    _this._fetchDataHandler = function (value) {
      var funcMapping = {
        none: _this._defaultFetchHandler,
        debounce: _this.state._debounceFetchHandler,
        trottle: _this.state._trottleFetchHandler
      };

      funcMapping[_this.props.rateLimitBy](value);
    };

    _this._getOptionsCount = function (options) {
      return options && (options.length || options.size || 0);
    };

    _this._getOption = function (options, index) {
      if (_immutable2.default.List.isList(options)) {
        return options.get(index);
      }
      return options[index];
    };

    _this._optionClick = function (index) {
      var options = _this.state.options;
      var displayKey = _this.props.displayKey;

      if (_this.props.onOptionClick) {
        var option = _this._getOption(options, index);
        _this.props.onOptionClick(option, index);
        if (_this.props.onOptionChange) {
          _this.props.onOptionChange(option, index);
        }
      }

      _this.setState({
        selectedIndex: index,
        dropdownVisible: false,
        value: _this._getValueByIndex(options, index, displayKey)
      });
    };

    _this._getHint = function (currentValue, nextValue) {
      var lowerCurrentValue = String(currentValue).toLowerCase();
      var lowerNextValue = String(nextValue).toLowerCase();
      if (lowerNextValue.toLowerCase().startsWith(lowerCurrentValue)) {
        return String(nextValue);
      }
      return '';
    };

    _this._onKeyDown = function (e) {
      var hint = _this.state.hint;
      var key = e.key;
      var options = _this.state.options;
      var dropdownVisible = _this.state.dropdownVisible;
      var selectedIndex = _this.state.selectedIndex;
      var displayKey = _this.props.displayKey;
      var value = _this.state.value;
      var hintValue = hint ? _this.state.hintValue : '';

      switch (key) {
        case 'Esc':
        case 'Escape':
          {
            e.preventDefault();
            _this.setState({
              dropdownVisible: false,
              emptyVisible: false,
              hintValue: ''
            });
            break;
          }
        case 'End':
        case 'Tab':
          {
            if (hint && !e.shiftKey) {
              if (hintValue) {
                e.preventDefault();
                _this.setState({
                  value: hintValue,
                  hintValue: '',
                  dropdownVisible: false
                });
              } else {
                _this.setState({
                  dropdownVisible: false
                });
              }
            }
            break;
          }
        case 'Enter':
          {
            if (_this._getOptionsCount(options) > 0) {
              _this.setState({
                value: _this._getValueByIndex(options, selectedIndex, displayKey),
                dropdownVisible: false
              });
              if (_this.props.onOptionChange) {
                _this.props.onOptionChange(options[selectedIndex], selectedIndex);
              }
            }
            break;
          }
        case 'ArrowUp':
        case 'ArrowDown':
          {
            var _ret = function () {
              e.preventDefault();
              var increment = key === 'ArrowUp' ? -1 : 1;
              var len = _this._getOptionsCount(options);
              var calcIndex = function calcIndex(length, curIndex) {
                var newIndex = curIndex + increment;
                if (newIndex < 0) {
                  newIndex += length;
                }
                return newIndex % length;
              };

              if (!dropdownVisible && options && len > 0) {
                var nextValue = _this._getValueByIndex(options, selectedIndex, displayKey);
                _this.setState({
                  dropdownVisible: true,
                  hintValue: hint ? _this._getHint(value, nextValue) : ''
                });
              }

              if (dropdownVisible && options && len > 0) {
                var newIndex = calcIndex(len, selectedIndex);
                var _nextValue = _this._getValueByIndex(options, newIndex, displayKey);
                _this.setState({
                  selectedIndex: newIndex,
                  hintValue: hint ? _this._getHint(value, _nextValue) : ''
                });
              }

              if (_this.state.showEmpty && !_this.state.emptyVisible) {
                _this.setState({
                  emptyVisible: true
                });
              }

              _this._setPosition(value.length);
              return 'break';
            }();

            if (_ret === 'break') break;
          }
        default:
          break;
      }
    };

    _this._setPosition = function (pos) {
      var input = _this._inputTypeAhead._input;
      if (input.setSelectionRange) {
        input.setSelectionRange(pos, pos);
      } else if (input.createTextRange) {
        var range = input.createTextRange();
        range.collapse(true);
        range.moveEnd('character', pos);
        range.moveStart('character', pos);
        range.select();
      }
    };

    _this._renderSpinner = function () {
      var LoadingTemplate = _this.props.loadingTemplate;
      if (_this.state.showLoading) {
        return _react2.default.createElement(LoadingTemplate, {
          className: 'rtex-spinner',
          dir: _this.state.direction,
          height: _this.state.height
        });
      }
      return null;
    };

    _this._getInputPlaceHolder = function (hintValue) {
      if (hintValue) {
        return '';
      }
      return _this.state.placeholder;
    };

    _this._renderInputs = function () {
      var value = _this.state.value;

      return _react2.default.createElement(
        _TypeaheadDiv2.default,
        { className: 'rtex-input-container' },
        _react2.default.createElement(_PresentationInput2.default, {
          disabled: true,
          role: 'presentation',
          'aria-hidden': true,
          value: _this.state.hintValue,
          className: 'rtex-hint ' + _this.props.className
        }),
        _react2.default.createElement(_ComboboxInput2.default, {
          innerRef: function innerRef(c) {
            _this._inputTypeAhead = c;
          },
          role: 'combobox',
          'aria-expanded': 'true',
          'aria-autocomplete': 'both',
          placeholder: _this._getInputPlaceHolder(_this.state.hintValue),
          value: value,
          spellCheck: false,
          autoComplete: false,
          autoCorrect: false,
          onFocus: _this._onFocus,
          onClick: _this._onClick,
          onBlur: _this._onBlur,
          onChange: _this._onChange,
          onKeyDown: _this._onKeyDown,
          className: 'rtex-input ' + _this.props.className
        }),
        _this._renderSpinner()
      );
    };

    _this._getOptionClasses = function (visible) {
      var defaultClasses = ['rtex-option-container'];
      if (visible) {
        defaultClasses.push('rtex-is-open');
      }
      return defaultClasses.join(' ');
    };

    _this._renderOptions = function () {
      var value = _this.state.value;
      var dropdownVisible = _this.state.dropdownVisible;
      var OptionTemplate = _this.props.optionTemplate;
      var options = _this.state.options;

      return _react2.default.createElement(
        _UlContainer2.default,
        {
          className: _this._getOptionClasses(dropdownVisible),
          visible: dropdownVisible
        },
        options.map(function (data, index) {
          var selected = _this.state.selectedIndex === index;
          return _react2.default.createElement(
            _LiContainer2.default,
            {
              selected: selected,
              optionIndex: index,
              key: index,
              onClick: _this._optionClick
            },
            _react2.default.createElement(OptionTemplate, {
              data: data,
              index: index,
              value: value,
              selected: selected
            })
          );
        })
      );
    };

    _this._renderEmpty = function () {
      var EmptyOptionTemplate = _this.props.emptyTemplate;
      if (!_this.state.dropdownVisible && _this.state.showEmpty && _this.state.emptyVisible) {
        return _react2.default.createElement(
          _UlContainer2.default,
          {
            className: 'rtex-option-container rtex-is-open rtex-empty',
            visible: true
          },
          _react2.default.createElement(
            _LiContainer2.default,
            null,
            _react2.default.createElement(EmptyOptionTemplate, null)
          )
        );
      }
      return null;
    };

    _this.state = {
      value: String(props.value),
      dropdownVisible: false,
      options: props.options,
      selectedIndex: -1,
      hint: props.hint,
      minLength: props.minLength,
      hintValue: '',
      showLoading: props.showLoading,
      direction: 'ltr',
      width: 0,
      height: 0,
      rateLimitBy: props.rateLimitBy,
      rateLimitWait: props.rateLimitWait,
      emptyVisible: false,
      showEmpty: props.showEmpty,
      placeholder: props.placeholder,
      _debounceFetchHandler: (0, _lodash2.default)(_this._defaultFetchHandler, props.rateLimitWait),
      _trottleFetchHandler: (0, _lodash4.default)(_this._defaultFetchHandler, props.rateLimitWait)
    };
    return _this;
  }

  (0, _createClass3.default)(Typeahead, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var value = this.state.value;
      document.addEventListener('click', this._onDocActivate);

      if (this.state.minLength && value.length >= this.state.minLength) {
        this._fetchDataHandler(value);
      }

      var _inputTypeAhead$_inpu = this._inputTypeAhead._input,
          clientHeight = _inputTypeAhead$_inpu.clientHeight,
          clientWidth = _inputTypeAhead$_inpu.clientWidth;
      /* eslint-disable react/no-did-mount-set-state */

      this.setState({
        height: clientHeight,
        width: clientWidth
      });
      /* eslint-enable react/no-did-mount-set-state */
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var dir = (0, _utils2.default)(this._inputTypeAhead._input);
      var value = String(nextProps.value);
      var displayKey = nextProps.displayKey;
      var options = nextProps.options;
      var hint = dir === 'rtl' ? false : nextProps.hint;
      var nextValue = this._getValueByIndex(options, 0, displayKey);
      var hintValue = hint ? this._getHint(value, nextValue) : '';
      var hasOptions = this._getOptionsCount(nextProps.options) > 0;
      var _inputTypeAhead$_inpu2 = this._inputTypeAhead._input,
          clientHeight = _inputTypeAhead$_inpu2.clientHeight,
          clientWidth = _inputTypeAhead$_inpu2.clientWidth;


      this.setState({
        value: value,
        options: nextProps.options,
        selectedIndex: this._getSelectedIndex(options, 0),
        hint: hint,
        minLength: nextProps.minLength,
        showLoading: nextProps.showLoading,
        dropdownVisible: hasOptions,
        hintValue: hint ? hintValue : '',
        direction: dir,
        width: clientWidth,
        height: clientHeight,
        rateLimitBy: nextProps.rateLimitBy,
        rateLimitWait: nextProps.rateLimitWait,
        showEmpty: nextProps.showEmpty,
        placeholder: nextProps.placeholder,
        _debounceFetchHandler: (0, _lodash2.default)(this._defaultFetchHandler, nextProps.rateLimitWait),
        _trottleFetchHandler: (0, _lodash4.default)(this._defaultFetchHandler, nextProps.rateLimitWait)
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this._onDocActivate);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        _TypeaheadContainer2.default,
        {
          ref: function ref(c) {
            _this2._container = c;
          },
          className: 'rtex-container'
        },
        this._renderInputs(),
        this._renderEmpty(),
        this._renderOptions()
      );
    }
  }]);
  return Typeahead;
}(_react.PureComponent);

Typeahead.defaultProps = {
  value: '',
  dropdownVisible: false,
  options: [],
  hint: true,
  minLength: 1,
  showLoading: false,
  loadingTemplate: defaultLoadingTemplate,
  emptyTemplate: EmptyTemplate,
  className: '',
  rateLimitBy: 'none',
  rateLimitWait: 100,
  showEmpty: false,
  emptyVisible: false,
  placeholder: ''
};
Typeahead.propTypes = {
  optionTemplate: _react2.default.PropTypes.func.isRequired,
  emptyTemplate: _react2.default.PropTypes.func,
  loadingTemplate: _react2.default.PropTypes.func,
  onChange: _react2.default.PropTypes.func,
  onFetchData: _react2.default.PropTypes.func,
  onBlur: _react2.default.PropTypes.func,
  onOptionClick: _react2.default.PropTypes.func,
  onOptionChange: _react2.default.PropTypes.func,
  onClick: _react2.default.PropTypes.func,
  displayKey: _react2.default.PropTypes.string.isRequired,
  hint: _react2.default.PropTypes.bool,
  minLength: _react2.default.PropTypes.number,
  showLoading: _react2.default.PropTypes.bool,
  value: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  options: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.instanceOf(_immutable2.default.List)]),
  rateLimitBy: _react2.default.PropTypes.oneOf(['none', 'trottle', 'debounce']),
  rateLimitWait: _react2.default.PropTypes.number,
  showEmpty: _react2.default.PropTypes.bool,
  placeholder: _react2.default.PropTypes.string
};
exports.default = Typeahead;